﻿Imports System.Drawing
Public Class Form1

    Dim step_motion As Integer
    'drawing on a bitmap
    Dim g As Graphics
    Dim line As Pen
    Dim mesh As Pen
    Dim img As Bitmap

    'line point
    Dim tmpx As Integer
    Dim tmpy As Integer
    Dim x As Integer
    Dim y As Integer

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Scan_XDI()
        Scan_YDI()
        ScanProperties()
    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MessageBox.Show("Please start your ISaGRAF application before press start button.", "Button Clicked", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
        Timer1.Interval = 250
        Timer1.Enabled = True
        'initial point
        tmpx = 0
        tmpy = 0

        'create bitmap canvas
        img = New Bitmap(pictureBox1.Size.Width, pictureBox1.Size.Height)
        g = Graphics.FromImage(img)
        pictureBox1.Image = img
        g.Clear(Color.White)

        'start drawing mesh
        draw_mesh()
    End Sub

    Private Sub draw_mesh()
        mesh = New Pen(Color.Silver)
        Dim i, j As Integer
        For i = 1 To 9
            g.DrawLine(mesh, i * 40, 0, i * 40, 240)
        Next


        For j = 1 To 7
            g.DrawLine(mesh, 0, j * 40, 320, j * 40)
        Next
        'release pen
        mesh.Dispose()
    End Sub

    Private Sub draw()
        line = New Pen(Color.Blue)

        g.DrawLine(line, x / 500, 240 - (y / 500), tmpx / 500, 240 - (tmpy / 500))
        pictureBox1.Refresh()
        'release pen
        line.Dispose()
    End Sub

    Private Sub showstep(ByVal motion_step As Integer)
        Select Case motion_step
            Case 0
                status_bar.Text = "Please press start button to start motion"
                g.Clear(Color.White)
                draw_mesh()

            Case 1
                status_bar.Text = "Detecting X-AXIS Near-home-switch and Home-Switch."

            Case 2
                status_bar.Text = "Detecting Y-AXIS Near-home-switch and Home-Switch."

            Case 3
                status_bar.Text = "Reset logic and encoder pulse"

            Case 4
                status_bar.Text = "Start line interpolation"

            Case 5
                status_bar.Text = "Move to start point of circle move"

            Case 6
                status_bar.Text = "start arc interpolation move"

            Case 7
                status_bar.Text = "Return home"
            Case 20
                status_bar.Text = "Wait 10 seconds"
            Case Else
                status_bar.Text = "error!!! Please check your ISaGRAF I/O connection or Manual."
                g.Clear(Color.White)
                draw_mesh()
        End Select
    End Sub
    Private Sub Scan_XDI()
        Dim status As Byte

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(2), status)
        If status = 1 Then
            Limit_XP.BackColor = Color.Red
        Else
            Limit_XP.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(3), status)

        If status = 1 Then
            Limit_XN.BackColor = Color.Red
        Else
            Limit_XN.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(6), status)
        If status = 1 Then
            Home_X.BackColor = Color.Red
        Else
            Home_X.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(7), status)

        If status = 1 Then
            NHome_X.BackColor = Color.Red
        Else
            NHome_X.BackColor = Color.Black
        End If

    End Sub
    Private Sub Scan_YDI()
        Dim status As Byte

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(4), status)
        If status = 1 Then
            Limit_YP.BackColor = Color.Red
        Else
            Limit_YP.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(5), status)
        If status = 1 Then
            Limit_YN.BackColor = Color.Red
        Else
            Limit_YN.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(8), status)

        If status = 1 Then
            Home_Y.BackColor = Color.Red
        Else
            Home_Y.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(9), status)
        If status = 1 Then
            NHome_Y.BackColor = Color.Red
        Else
            NHome_Y.BackColor = Color.Black
        End If
    End Sub
    Private Sub ScanProperties()

        Dim Value As Integer
        Value = 0
        Dim tmp As Byte
        Dim position As String

        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(10), Value)
        speed.Text = Value.ToString()

        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(12), Value)
        position = "( " + Value.ToString() + " , "

        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(14), Value)
        position += Value.ToString() + " )"
        nxt_position.Text = position



        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(16), x)
        position = "( " + x.ToString() + " , "

        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(18), y)
        position += y.ToString() + " )"

        cur_position.Text = position

        If (x - tmpx) * (x - tmpx) > 500 Or (y - tmpy) * (y - tmpy) > 500 Then

            draw()
            tmpx = x
            tmpy = y
        End If
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(20), step_motion)

        'check emergency signal
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(22), tmp)
        If tmp = 0 Then

            emg.BackColor = Color.Black
            showstep(step_motion)

        Else

            emg.BackColor = Color.Red
            step_motion = -1
            showstep(step_motion)
        End If

    End Sub

    Private Sub button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Quicker.UserShare.UserSetCoil(Convert.ToUInt16(1), 1)

        pictureBox1.Refresh()
    End Sub

End Class
