﻿Imports System.Drawing

Public Class Form1
    Structure draw_point

        Public x1 As Integer
        Public y1 As Integer
        Public x2 As Integer
        Public y2 As Integer
    End Structure
    'initial varible
    Dim line_point As draw_point
    Dim lin_pic As Graphics
    Dim lin_img As Bitmap
    'create a new



    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        MessageBox.Show("Please start your ISaGRAF application before press start button.", "Button Clicked", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
        'set timer
        Timer1.Interval = 250
        Timer1.Enabled = True

        'create bitmap and draw mesh for draw line 
        lin_img = New Bitmap(line_pic.Size.Width, line_pic.Height)
        lin_pic = Graphics.FromImage(lin_img)
        line_pic.Image = lin_img
        lin_pic.Clear(Color.White)


        'start drawing mesh
        draw_mesh(lin_pic, line_pic.Size.Width, line_pic.Size.Height, 10)
        line_pic.Refresh()

        'initial struct line
        line_point.x1 = 0
        line_point.y1 = 240

    End Sub

    Private Sub draw_mesh(ByVal g As Graphics, ByVal width As Integer, ByVal height As Integer, ByVal radix As Integer)


        Dim mesh As Pen
        mesh = New Pen(Color.Silver)

        Dim i As Integer
        Dim j As Integer
        For i = 1 To width / radix

            g.DrawLine(mesh, i * radix, 0, i * radix, height)
        Next

        For j = 0 To height / radix

            g.DrawLine(mesh, 0, j * radix, width, radix * j)
        Next

        mesh.Dispose()
    End Sub

    Private Sub draw_line(ByVal g As Graphics, ByVal line_point As draw_point)
        Dim line As Pen
        line = New Pen(Color.Blue)
        g.DrawLine(line, line_point.x1, line_point.y1, line_point.x2, line_point.y2)
        line.Dispose()
    End Sub
    Private Sub ScanDI()

        'scan all di value
        Dim di_value As Byte
        di_value = 0
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(15), di_value)
        If di_value = 1 Then

            SRV_X.BackColor = Color.Red

        Else

            SRV_X.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(16), di_value)
        If di_value = 1 Then

            SRV_Y.BackColor = Color.Red

        Else

            SRV_Y.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(17), di_value)
        If di_value = 1 Then

            SRV_Z.BackColor = Color.Red

        Else

            SRV_Z.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(18), di_value)
        If di_value = 1 Then

            DRV_X.BackColor = Color.Red

        Else

            DRV_X.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(19), di_value)
        If di_value = 1 Then

            DRV_Y.BackColor = Color.Red

        Else

            DRV_Y.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(20), di_value)
        If di_value = 1 Then

            DRV_Z.BackColor = Color.Red

        Else

            DRV_Z.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(21), di_value)
        If di_value = 1 Then

            EMG.BackColor = Color.Red
            switch_step(-1)

        Else

            EMG.BackColor = Color.Black
        End If

    End Sub
    Private Sub ScanProperties()

        'scan all intger varible in ISaGRAF
        Dim Value As Integer
        Dim step_motion As Integer
        Dim position As String

        'read Encode X,Y,Z
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(24), Value)
        position = "(" + Value.ToString() + " , "
        line_point.x2 = Value / 500

        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(26), Value)
        position += Value.ToString() + " , "
        line_point.y2 = 240 - (Value / 500)

        'draw line to picture box
        draw_line(lin_pic, line_point)
        line_pic.Refresh()
        'swap point
        line_point.x1 = line_point.x2
        line_point.y1 = line_point.y2

        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(28), Value)
        position += Value.ToString() + " )"
        'show current position
        cur_position.Text = position.ToString()

        'read Pulse to move X,Y,Z
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(30), Value)
        position = "(" + Value.ToString() + " , "
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(32), Value)
        position += Value.ToString() + " , "
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(34), Value)
        position += Value.ToString() + " )"

        'show next position
        nxt_position.Text = position.ToString()

        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(36), step_motion)
        switch_step(step_motion)


    End Sub

    Private Sub ScanXDI()
        'Scan X axis D/I status
        Dim di_value As Byte

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(3), di_value)
        If di_value = 1 Then

            LimitP_X.BackColor = Color.Red

        Else

            LimitP_X.BackColor = Color.Black
        End If
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(4), di_value)
        If di_value = 1 Then

            LimitN_X.BackColor = Color.Red

        Else

            LimitN_X.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(5), di_value)
        If di_value = 1 Then

            NHome_X.BackColor = Color.Red

        Else

            NHome_X.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(6), di_value)
        If di_value = 1 Then

            Home_X.BackColor = Color.Red

        Else

            Home_X.BackColor = Color.Black
        End If
    End Sub
    Private Sub ScanYDI()
        'Scan Y axis D/I status
        Dim di_value As Byte
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(7), di_value)
        If di_value = 1 Then

            LimitP_Y.BackColor = Color.Red

        Else

            LimitP_Y.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(8), di_value)
        If di_value = 1 Then

            LimitN_Y.BackColor = Color.Red

        Else

            LimitN_Y.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(9), di_value)
        If di_value = 1 Then

            NHome_Y.BackColor = Color.Red

        Else

            NHome_Y.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(10), di_value)
        If di_value = 1 Then

            Home_Y.BackColor = Color.Red

        Else

            Home_Y.BackColor = Color.Black
        End If
    End Sub
    Private Sub ScanZDI()
        'Scan Z axis D/I status
        Dim di_value As Byte
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(11), di_value)
        If di_value = 1 Then

            LimitP_Z.BackColor = Color.Red

        Else

            LimitP_Z.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(12), di_value)
        If di_value = 1 Then

            LimitN_Z.BackColor = Color.Red

        Else

            LimitN_Z.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(13), di_value)
        If di_value = 1 Then

            NHome_Z.BackColor = Color.Red

        Else

            NHome_Z.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(14), di_value)
        If di_value = 1 Then

            Home_Z.BackColor = Color.Red
        Else

            Home_Z.BackColor = Color.Black
        End If
    End Sub


    Private Sub switch_step(ByVal motion_step As Integer)
        'show SFC program status from step value
        Select (motion_step)

            Case 0
                status_bar.Text = "Please press start button to start motion"
                lin_pic.Clear(Color.White)
                draw_mesh(lin_pic, line_pic.Size.Width, line_pic.Size.Height, 10)

            Case 1
                status_bar.Text = "Detecting X-AXIS Near-home-switch and Home-Switch."

            Case 2
                status_bar.Text = "Detecting Y-AXIS Near-home-switch and Home-Switch."

            Case 3
                status_bar.Text = "Detecting Z-AXIS Near-home-switch and Home-Switch."

            Case 4
                status_bar.Text = "Start Z Axis motion"

            Case 5
                status_bar.Text = "Start Line interpolation move"

            Case 6
                status_bar.Text = "start arc interpolation move"

            Case 7
                status_bar.Text = "Return home motion(X and Y axis)"

            Case 8
                status_bar.Text = "Return home motion(Z axis)"
                lin_pic.Clear(Color.White)
                draw_mesh(lin_pic, line_pic.Size.Width, line_pic.Size.Height, 10)
            Case 9
                status_bar.Text = "Please press start button to start motion"
            Case 20
                status_bar.Text = "Wait a second"

            Case Else
                status_bar.Text = "error!!! Please check your ISaGRAF I/O connection or Manual."
                lin_pic.Clear(Color.White)
                draw_mesh(lin_pic, line_pic.Size.Width, line_pic.Size.Height, 10)
        End Select

    End Sub


    Private Sub start_bt_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles start_bt.Click
        'start motion
        Dim step_motion As Integer
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(36), step_motion)
        If step_motion = 9 Then
            lin_pic.Clear(Color.White)
            draw_mesh(lin_pic, line_pic.Size.Width, line_pic.Size.Height, 10)
        End If

        Quicker.UserShare.UserSetCoil(Convert.ToUInt16(1), 1)

        line_pic.Refresh()
    End Sub

    Private Sub stop_bt_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles stop_bt.Click
        Quicker.UserShare.UserSetCoil(Convert.ToUInt16(2), 1)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ScanDI() 'scan serve on ,Drive and EMG signal.
        'Scan X,Y,Z D/I status 
        ScanXDI()
        ScanYDI()
        ScanZDI()
        ScanProperties()
    End Sub
End Class
